/*
Intel Hex Checksum calculator by A. Wolf
October 2017

tutorial: http://www.keil.com/support/docs/1584/



*/

unsigned char buffer1[] = ":10246200464C5549442050524F46494C4500464C33";        // corect Hex Line - http://www.keil.com/support/docs/1584/
unsigned char buffer2[] = ":10246200464C5549442050524F46494C4500464D33";        // hex line with byteflip
unsigned char buffer3[] = ":10010000214601360121470136007EFE09D2190140";        // example from Wikipedia Germany https://de.wikipedia.org/wiki/Intel_HEX


/*
  :10246200464C5549442050524F46494C4500464C33
  |||||||||||                              CC->Checksum
  |||||||||DD->Data
  |||||||TT->Record Type
  |||AAAA->Address
  |LL->Record Length
  :->Colon
*/


// return:
// +1 = checksum Hex Line corect
// -1 = checksum Hex Line wrong
short checksumCheck( unsigned char * ptrIntern ){
  unsigned short hexRawLineIntern[1+2+4+2+32+2+2];//1-start of  row, 2-num data bytes, 4-address, 2-type, 32- ascii data, 2- checksum, 2 <LF><CR>
  unsigned short result = 0;
  unsigned short checkSumCalculated = 0;
  unsigned short checkSumIdentified = 0;
  unsigned short recordLength = 0;
  unsigned short adress1 = 0;
  unsigned short adress2 = 0;
  unsigned short recordType = 0;
  unsigned short i = 0;
  unsigned int   digitSum = 0;

  if( *ptrIntern != ':'){
      return -1;
   }
  ptrIntern++;
  for(i = 0; i < 45; i++){ // copy hex line into internal buffer, convert it to numbers and copy it to internal array
      result = *ptrIntern;
      hexRawLineIntern[i] = xtoi( &result );
      ptrIntern++;
      }

  recordLength =  (hexRawLineIntern[0] << 4) | hexRawLineIntern[1];
  adress1      = ((hexRawLineIntern[2] << 4) | hexRawLineIntern[3]);
  adress2      = ((hexRawLineIntern[4] << 4) | hexRawLineIntern[5]);
  recordType   = ((hexRawLineIntern[6] << 4) | hexRawLineIntern[7]);
  digitSum    = recordLength + adress1 + adress2 + recordType;
 
 /*
  digitSum2 = recordLength +                                        // record Length
             ((hexRawLineIntern[2] << 4) | hexRawLineIntern[3]) +   // Adress Part1
             ((hexRawLineIntern[4] << 4) | hexRawLineIntern[5]) +   // Adress PArt2
             ((hexRawLineIntern[6] << 4) | hexRawLineIntern[7]);    // Record Type
  */
  for( i = 1; i <= recordLength*2; i+= 2){    // sum up data bytes
       result = (hexRawLineIntern[i+7] << 4) | hexRawLineIntern[i+8];
       digitSum += result;
      }
  checkSumIdentified = (hexRawLineIntern[i+7] << 4) | hexRawLineIntern[i+8];    // get Checksum from Array
  
  result = (unsigned char) digitSum ; // mask to least significant Byte
  result = ~result;                   // two complement   ~ bitwise complement (unary); inverts each bit
  checkSumCalculated = result + 1;    // add 1

  if( checkSumCalculated == checkSumIdentified)
      return +1;

  return -1;
}


void main() {
  volatile short result1 = 0;
  volatile short result2 = 0;
  volatile short result3 = 0;
  int i;
    
  result1 = checksumCheck(buffer1);
  result2 = checksumCheck(buffer2);
  result3 = checksumCheck(buffer3);
    
  while(1){
          i = result1 + result2 + result3 + 1; // nonesense, but compiler doesnt remove this
         }
}